using System;
using System.Collections.Generic;
using System.Text;

namespace CodePlex.XmlDataMapper.ConsoleClient.Dto
{
   //Warning: Strongly reccommend you use layering and place DTOs in a seperate DTO / Model layer
   //Keeping folder structure in the demo just for illustration
   [Serializable]
   public class Order
   {
      public Order() {/*no-op*/}

      private int id;
      private string name;
      private DateTime? orderDate;
      private byte orderStatusId;
      private bool isComplete;
      private string comments;
      private decimal amount;
      private bool isActive;

      private IList<OrderDetail> orderDetails;

      public int Id 
      { 
         get { return this.id; } 
         set { this.id = value; } 
      }
      public string Name
      {
         get { return this.name; }
         set { this.name = value; }
      }
      public DateTime? OrderDate
      {
         get { return this.orderDate; }
         set { this.orderDate = value; }
      }
      public byte OrderStatusId
      {
         get { return this.orderStatusId; }
         set { this.orderStatusId = value; }
      }
      public bool IsComplete
      {
         get { return this.isComplete; }
         set { this.isComplete = value; }
      }
      public string Comments
      {
         get { return this.comments; }
         set { this.comments = value; }
      }
      public decimal Amount
      {
         get { return this.amount; }
         set { this.amount = value; }
      }
      public bool IsActive
      {
         get { return this.isActive; }
         set { this.isActive = value; }
      }

      public IList<OrderDetail> OrderDetails 
      {
         get 
         {
            if (this.orderDetails == null) 
               this.orderDetails = new List<OrderDetail>(); 
            return this.orderDetails;
         }
         set { this.orderDetails = value; }
      }

      //TODO:Later: //public OrderExtension OrderExtension { get; set; }

      public OrderStatusFlags OrderStatus
      {
         get { return (OrderStatusFlags)this.OrderStatusId; }
         set { this.OrderStatusId = (byte)value; }
      }
   }
}
//Copyright Binoj V Antony  2010 under GNU Library General Public License (LGPL) at http://XmlDataMapper.CodePlex.com/
//Please preserve the authors names and copyright statement in the code even when the work is changed or added to.