using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using System.Globalization;

using CodePlex.XmlDataMapper;
using CodePlex.XmlDataMapper.ConsoleClient.Dto;

namespace CodePlex.XmlDataMapper.ConsoleClient
{
   public static class OrderRandomizer
   {
      private static int orderCount = 0;

      public static Order GetOrder()
      {
         System.Threading.Interlocked.Increment(ref orderCount);
         System.Random random = new Random();
         Order order1 = new Order();
         order1.Amount = (decimal)(random.Next(10, 500) + ((random.Next(1, 10) / 2) * 0.1));
         order1.Name = "Record # " + System.DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss:fff", CultureInfo.InvariantCulture) + " " + orderCount;
         order1.OrderDate = DateTime.Now;
         order1.Comments = System.DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss:fff", CultureInfo.InvariantCulture);
         order1.OrderStatus = OrderStatusFlags.InProcess;
         order1.Id = random.Next(1, 1000);
         return order1;
      }

      public static IList<Order> GetOrders(int count)
      {
         IList<Order> list = new List<Order>(count);
         for (int i = 0; i < count; i++)
         {
            list.Add(GetOrder());
            System.Threading.Thread.Sleep(10);
         }
         return list;
      }

      //Sample on how to convert IList<dto> into DataTable
      public static DataTable GetOrdersDataTable(int count)
      {
         return DTOConverter<Order>.ConvertToDataTable(GetOrders(count));
      }

      public static IDataReader GetOrdersDataReader(int count)
      {
         return GetOrdersDataTable(count).CreateDataReader();
      }
   }
}
//Copyright Binoj V Antony  2010 under GNU Library General Public License (LGPL) at http://XmlDataMapper.CodePlex.com/
//Please preserve the authors names and copyright statement in the code even when the work is changed or added to.